/****************************************************************************
 *    Copyright 2010 Andy Kirkham, Stellar Technologies Ltd
 *    
 *    This file is part of the Satellite Observers Workbench (SOWB).
 *
 *    SOWB is free software: you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation, either version 3 of the License, or
 *    (at your option) any later version.
 *
 *    SOWB is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with SOWB.  If not, see <http://www.gnu.org/licenses/>.
 *
 *    $Id: main.cpp 5 2010-07-12 20:51:11Z ajk $
 *    
 ***************************************************************************/

#ifdef NEVERCOMPILETHIS

#ifndef MBEDFILESYS_H
#define MBEDFILESYS_H

#include "satapi.h"

#define SOWB_FILE_OK                1
#define SOWB_FILE_NOT_FOUND         -1
#define SOWB_FILE_INDEX_NOT_FOUND   -2
#define SOWB_FILE_EOF_REACHED       -3

int get_first_tle_from_file(const char *filename, SAT_POS_DATA *sat);
int get_next_tle_from_file(const char *filename, SAT_POS_DATA *sat);

void process_tle(SAT_POS_DATA *sat);

#endif

#endif

